=== books/projects/masc/examples/Makefile ===

all:

clean:

veryclean: clean
	rm -f *.cert *.lx64fsl *.port *.log *.lisp *.m *.types.h *.decs.h *.out *.ctos.cpp *.i imul/*.cert imul/*.lx64fsl imul/*.port imul/*.log imul/*.lisp imul/*.m imul/*.types.h imul/*.decs.h imul/*.out imul/*.ctos.cpp imul/*.i
