=== debian/changelog ===
acl2 (7.2dfsg-3) unstable; urgency=medium

  * build-dep against latest gcl
  * upstream pathname patch

 -- Camm Maguire <camm@debian.org>  Sat, 15 Oct 2016 11:39:07 +0000

acl2 (7.2dfsg-2) unstable; urgency=medium

  * Bug fix: "FTBFS in kfreebsd-amd64", thanks to Andreas Beckmann
    (Closes: #815312).  Reduce GCL_MEM_MULTIPLE setting.
  * Bug fix: "FTBFS in stretch (looks like the same problem in maxima)",
    thanks to Santiago Vila (Closes: #819447).

 -- Camm Maguire <camm@debian.org>  Tue, 03 May 2016 15:05:07 +0000

acl2 (7.2dfsg-1) unstable; urgency=medium

  * New upstream release
  * Bug fix: "Please do not hide the output from tests", thanks to
    Santiago Vila (Closes: #819446).
  * Bug fix: "FTBFS in stretch (looks like the same problem in maxima)",
    thanks to Santiago Vila (Closes: #819447).

 -- Camm Maguire <camm@debian.org>  Wed, 13 Apr 2016 13:11:10 +0000

acl2 (7.1dfsg-2) unstable; urgency=medium

  * rebuild latest gcl, tail recursive equal works around setrlimit bug on
    s390

 -- Camm Maguire <camm@debian.org>  Tue, 27 Oct 2015 19:33:53 +0000

acl2 (7.1dfsg-1) unstable; urgency=medium

  * Bug fix: "[acl2] Some sources are not included in your package",
    thanks to Bastien ROUCARIÈS (Closes: #787368).
    Repackage to add missing  sources and delete questionable files.
    Removed files in orig tarball that are removed by clean target:
    books/workshops/1999/ivy/ivy-v2/ivy-sources/arithmetic.lisp.bak
    books/workshops/1999/ivy/ivy-v2/ivy-sources/util/checker.orig
    books/workshops/1999/ivy/ivy-v2/ivy-sources/util/make-saved-ivy.orig
    books/workshops/1999/ivy/ivy-v2/ivy-sources/util/sivy.orig
    books/workshops/1999/ivy/ivy-v2/ivy-sources/util/ivy.orig
    Removed sparc binary inadvertently included in upstream:
    books/workshops/2003/schmaltz-al-sammane-et-al/support/acl2link
    Added katex sources to debian/missing-sources:
    debian/missing-sources/books/xdoc/fancy/lib/katex/katex.js
    debian/missing-sources/books/xdoc/fancy/lib/katex/katex.min.css
    debian/missing-sources/books/xdoc/fancy/lib/katex/src/*
    Removed rfc file with non-dfsg licence:
    books/centaur/quicklisp/bundle/software/rfc2388-20130720-git/doc/rfc2388.txt
    Added source to debian/missing-sources to remove a lintian false positive:
    debian/missing-sources/books/workshops/2000/shumsky/slides2_files/script.js
  * build-dep latest gcl
  * updated README.Debian.in
  * remove clisp scripts from acl2-books-source
  * remove .gitignore from acl2-doc
  * added lintian override for (non) extra-license-file
    books/centaur/aignet/copying.cert

 -- Camm Maguire <camm@debian.org>  Wed, 21 Oct 2015 02:21:10 +0000

acl2 (7.1-3) unstable; urgency=medium

  * don't pre-allocate contiguous blocks in acl2.lisp
  * build-dep latest gcl
  * revert code-block-reserve to default set by upstream

 -- Camm Maguire <camm@debian.org>  Fri, 09 Oct 2015 01:09:05 +0000

acl2 (7.1-2) unstable; urgency=medium

  * build-dep latest gcl
  * 50M code-block-reserve on amd64

 -- Camm Maguire <camm@debian.org>  Mon, 28 Sep 2015 15:57:09 +0000
