=== debian/changelog ===
acl2 (7.4dfsg-4) unstable; urgency=medium

  * Accept NMU, thanks to Sean Whitton
  * build-dep latest gcl

 -- Camm Maguire <camm@debian.org>  Tue, 29 Aug 2017 23:11:16 +0000

acl2 (7.4dfsg-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Bump {build-,}deps emacs24 -> emacs25 (Closes: #870663).

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 03 Aug 2017 17:27:43 -0400

acl2 (7.4dfsg-3) unstable; urgency=medium

  * build-dep latest gcl
  * revert mxgot for mips64

 -- Camm Maguire <camm@debian.org>  Thu, 08 Jun 2017 22:34:51 +0000

acl2 (7.4dfsg-2) unstable; urgency=medium

  * Set GCL_MULTIPROCESS_MEMORY_POOL for certifications
  * build-dep latest gcl for mips64el fix
  * Bug fix: "build fails on mips (mips-aql-05)", thanks to Héctor Orón
    Martínez (Closes: #863224).
  * mxgot .acl2 files patch

 -- Camm Maguire <camm@debian.org>  Sun, 28 May 2017 12:14:24 +0000

acl2 (7.4dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Camm Maguire <camm@debian.org>  Mon, 08 May 2017 16:58:52 +0000
