=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: math
 Priority: optional
 Maintainer: Camm Maguire <camm@debian.org>
-Build-Depends: gcl ( >= 2.6.12-41), libgmp3-dev, libreadline-dev, emacs24 | emacsen, debhelper ( >= 5), texlive-latex-recommended, libxmu-dev, libxaw7-dev, time, tex-common, texinfo
+Build-Depends: gcl ( >= 2.6.12-57), libgmp3-dev, libreadline-dev, emacs25 | emacsen, debhelper ( >= 5), texlive-latex-recommended, libxmu-dev, libxaw7-dev, time, tex-common, texinfo
 Standards-Version: 3.9.8
 
 Package: acl2
@@ -29,7 +29,7 @@
 
 Package: acl2-emacs
 Architecture: all
-Depends: acl2 (>= ${source:Version}), emacs24 | emacsen, ${misc:Depends}
+Depends: acl2 (>= ${source:Version}), emacs25 | emacsen, ${misc:Depends}
 Conflicts: acl2 (<= 2.7-9)
 Replaces: acl2 (<= 2.7-9)
 Description: Computational Logic for Applicative Common Lisp: emacs interface
